//structure du systeme PackMan
//TRACE PARSING;

//===========================================================================
// ATELIER 1
//===========================================================================

// *****************************************************************
// le systeme technique
// *****************************************************************

+ I robinetAlim leRobinetAlim_1
	debit = <pr><"CUVE" "debitAlim">;
;

+ I robinetVidange leRobinetVidange_1
	debit = <pr><"CUVE" "debitVidange">;
;

+I generateurDeBriques leGenerateur_1
	probaPetiteBrique = <pr><"CONVOYEUR" "probaPetite">;
;

+ I reserveCubis laReserveCubis_1
		POUR i3 = (1) A (10) 
			+ E cubitainer,;
		FIN POUR	
;

+ I magasinExpedition leMagasin_1
	+ E loge lesPetitsPacks_1
		contenance = 100;
	;
	+ E loge lesGrandsPacks_1
		contenance = 100;
	;
;

+ I rebut leRebut_1
	+ E logeRebut lesPetitsRebuts_1
		contenance = 50;
	;
	+ E logeRebut lesGrandsRebuts_1
		contenance = 50;
	;
;

+ I maxiBrique uneMaxiBrique_1;

{i1} = <pi><"CONVOYEUR"  "longueur">;

+ I atelierRemplissage latelier_1,
	+ C cuve laCuve_1
		<- C <I><,leRobinetAlim_1>;
		<- C <I><,leRobinetVidange_1>;
		volume = <pr><"CUVE" "Volume">;
		volumeMiniContenu = <pr><"CUVE" "VolumeMiniContenu">;
		volumeMaxiContenu = <pr><"CUVE" "VolumeMaxiContenu">;
		volumeContenu     = <pr><"CUVE" "VolumeInitial"> no_monitor;
	;
	<- C <I><, laReserveCubis_1>;
	+ C convoyeur leConvoyeur_1
		convoyeurGenerateur = <I><,leGenerateur_1>;
		convoyeurPlateforme << <I><, uneMaxiBrique_1>;
		POUR i2 = (2) A ({i1})
			convoyeurPlateforme << I positionVide,; ;
		FIN POUR	
	;
	<- C <I><, leMagasin_1>;
	<- C <I><, leRebut_1>;
;

// *****************************************************************
// le systeme oprant
// *****************************************************************

+ I ouvrier lOperateurConvoyeur_1
	availabilityStatus = 0;
	power = 0.25;
;

+ I simpleResourcePool lePoolOuvrier_1,
	<- E <I><, lOperateurConvoyeur_1>;
;

// *****************************************************************
// lments de la strategie
// *****************************************************************

//---------------------
// spcifications
//---------------------

+ I atelierMisEnRoute lAtelierSpec_1,
	selectorFctId = 1; // ANYONE=1, MAX=2, ALL=3, DISJ=4, SETS=5
	entitySpecReferentEntity = <I><, latelier_1>;  // + JPR 090130
;

+ I operatedObjectSpecification leConvoyeurSpec_1,
	preExpandedList << <I><, leConvoyeur_1>;
;

+ I operatedObjectSpecification leRebutSpec_1,
	preExpandedList << <I><, leRebut_1>;
;

+ I packDestination lePackSpec_1,                         // modif JPR 090130
	selectorFctId = 1; // ANYONE=1
	entitySpecReferentEntity = <I><, leConvoyeur_1>;  // + JPR 090130
;

+ I ouvrierAgissant lOuvrierSpec_1,
	preExpandedList << <I><, lOperateurConvoyeur_1>;
;

//---------------------
// activits primitives
//---------------------

+ I miseEnRoute laMiseEnRoute_1
	operatedObjectSpecAttribute = <I><, lAtelierSpec_1>;
;

+ I creationPack uneCreationPack_1
	operatedObjectSpecAttribute = <I><, leConvoyeurSpec_1>;
;

+ I remplissagePack unRemplissagePack_1 
	operatedObjectSpecAttribute = 
		+ I operatedObjectSpecification,
			preExpandedList << <I><, laCuve_1>;
		; 
	;
	destinationSpecAttribute = 
		<I><, lePackSpec_1>;
	transferInformationAttribute = 
		+ I infoTransfertCuvePack info1;
	;
;

+ I fermetureBriquesPack desFermeturesBriques_1
	operatedObjectSpecAttribute = <I><, lePackSpec_1>;
;

+ I conditionnementPack unConditionnementPack_1
	operatedObjectSpecAttribute = <I><, lePackSpec_1>;
        performerSpecAttribute = <I><, lOuvrierSpec_1>; // modif JPR 090130
;

+ I stockagePack unStockagePack_1
	operatedObjectSpecAttribute = <I><, leConvoyeurSpec_1>;
;

+ I miseAuRebut uneMiseAuRebut_1
	operatedObjectSpecAttribute = <I><, leRebutSpec_1>;
;

+ I arretProduction lArretProduction_1
	operatedObjectSpecAttribute = <I><, lAtelierSpec_1>;
;

+ I alimentationManuelle uneAlimManuelle_1
	operatedObjectSpecAttribute = 
		+ I operatedObjectSpecification,
			preExpandedList << <I><, laReserveCubis_1>;
		; 
	;
;

//---------------------
// activits agrges
//---------------------

+ I activityOptional alimManuelleIfNeeded_1
	<- E <I><, uneAlimManuelle_1>;
	isOneShot = 1; 
;

+ I sequenceMiseEnMagasin uneMiseEnMagasin_1
	<- E <I><, uneCreationPack_1>;
	<- E <I><, unRemplissagePack_1>;
	<- E <I><, desFermeturesBriques_1>;
	<- E <I><, unConditionnementPack_1>;
	<- E <I><, unStockagePack_1>;
; 

+ I iterationMagasinOuRebut laProduction_1
	+ E activityConjunction unCycleDeProduction_1,
		+ E activityDisjunction magasinOuRebut_1,
				<- E <I><, uneMiseEnMagasin_1>;
				//
				<- E <I><, uneMiseAuRebut_1>;
		;
		<- E <I><,alimManuelleIfNeeded_1>;
	;
;

//---------------------
// finalement, le plan
//---------------------
<I> <,iterationPlagesTravail_1>
	+ E activityBefore sequencePlageTravail_1,
		<- E <I><, laMiseEnRoute_1>;
		//
		<- E <I><, laProduction_1>;
		//
		<- E <I><, lArretProduction_1>;
	;

      	readyToRun = 1; 
;

// *****************************************************************
// la strategie du manager
// *****************************************************************

+ I activitiesResourcesBlock arb1_1
	<- C <I><, iterationPlagesTravail_1>;
	<- C <I><, lePoolOuvrier_1>;
	attachedEntity = <I><, latelier_1>;  // + JPR 090130
;

// ************************************************************************
// la dynamique du systme
// ************************************************************************

+ P fluxEntreeCuveLectureProcess lectureFluxEntree_1
	PAS = 5;  // 5 minutes
	NOM_SIMPLE_FICHIER "flux_1.txt";
        ENTITE_CIBLE = <I><, laCuve_1>;
	INIT_PRCD_EVT	DATE_OCCUR = 0;
			PRIORITE = 0;
	;
;

// -------------------------------------
// on programme la premire arrive de l'ouvrier
// -------------------------------------
{i2} = <pi><"POSTE" "heureDebutAM"> - <pi><"SIMULATION" "heureDebut">;
+ V arriveeOuvrier debutPoste_1  // on veut que ce soit  'heureDebutAM', donc ...
	DATE_OCCUR = {i2}*60;  // UT = 1 minute
	I resourceMobilizationProcess = <I><ouvrier lOperateurConvoyeur_1>;
// Prcision ci-dessus : explicite mais non ncessaire parce que, par dfaut,
// il y a un ProcessedEntityClassId(RESOURCE) dans le constructeur de 
// ResourceMobilizationProcess. L'entit opre est donc, par dfaut, 
// la premire instance de RESOURCE. Ici, c'est aussi la seule : l'ouvrier.
;

END INCLUDE;
