//structure du systeme PackMan
//TRACE PARSING;

//===========================================================================
// ATELIER 2
//===========================================================================

// *****************************************************************
// le systeme technique
// *****************************************************************

+ I robinetAlim leRobinetAlim_2
	debit = <pr><"CUVE" "debitAlim">;
;

+ I robinetVidange leRobinetVidange_2
	debit = <pr><"CUVE" "debitVidange">;
;

+I generateurDeBriques leGenerateur_2
	probaPetiteBrique = <pr><"CONVOYEUR" "probaPetite">;
;

+ I reserveCubis laReserveCubis_2
		POUR i3 = (1) A (10) 
			+ E cubitainer,;
		FIN POUR	
;

+ I magasinExpedition leMagasin_2
	+ E loge lesPetitsPacks_2
		contenance = 100;
	;
	+ E loge lesGrandsPacks_2
		contenance = 100;
	;
;

+ I rebut leRebut_2
	+ E logeRebut lesPetitsRebuts_2
		contenance = 50;
	;
	+ E logeRebut lesGrandsRebuts_2
		contenance = 50;
	;
;

+ I maxiBrique uneMaxiBrique_2;

{i1} = <pi><"CONVOYEUR"  "longueur">;

+ I atelierRemplissage latelier_2,
	+ C cuve laCuve_2
		<- C <I><,leRobinetAlim_2>;
		<- C <I><,leRobinetVidange_2>;
		volume = <pr><"CUVE" "Volume">;
		volumeMiniContenu = <pr><"CUVE" "VolumeMiniContenu">;
		volumeMaxiContenu = <pr><"CUVE" "VolumeMaxiContenu">;
		volumeContenu     = <pr><"CUVE" "VolumeInitial"> no_monitor;
	;
	<- C <I><, laReserveCubis_2>;
	+ C convoyeur leConvoyeur_2
		convoyeurGenerateur = <I><,leGenerateur_2>;
		convoyeurPlateforme << <I><, uneMaxiBrique_2>;
		POUR i2 = (2) A ({i1})
			convoyeurPlateforme << I positionVide,; ;
		FIN POUR	
	;
	<- C <I><, leMagasin_2>;
	<- C <I><, leRebut_2>;
;

// *****************************************************************
// le systeme oprant
// *****************************************************************

+ I ouvrier lOperateurConvoyeur_2
	availabilityStatus = 0;
	power = 0.25;
;

+ I simpleResourcePool lePoolOuvrier_2,
	<- E <I><, lOperateurConvoyeur_2>;
;

// *****************************************************************
// lments de la strategie
// *****************************************************************

//---------------------
// spcifications
//---------------------

+ I atelierMisEnRoute lAtelierSpec_2,
	selectorFctId = 1; // ANYONE=1, MAX=2, ALL=3, DISJ=4, SETS=5
	entitySpecReferentEntity = <I><, latelier_2>;  // + JPR 090130
;

+ I operatedObjectSpecification leConvoyeurSpec_2,
	preExpandedList << <I><, leConvoyeur_2>;
;

+ I operatedObjectSpecification leRebutSpec_2,
	preExpandedList << <I><, leRebut_2>;
;

+ I packDestination lePackSpec_2,                         // modif JPR 090130
	selectorFctId = 1; // ANYONE=1
	entitySpecReferentEntity = <I><, leConvoyeur_2>;  // + JPR 090130
;

+ I ouvrierAgissant lOuvrierSpec_2,
	preExpandedList << <I><, lOperateurConvoyeur_2>;
;

//---------------------
// activits primitives
//---------------------

+ I miseEnRoute laMiseEnRoute_2
	operatedObjectSpecAttribute = <I><, lAtelierSpec_2>;
;

+ I creationPack uneCreationPack_2
	operatedObjectSpecAttribute = <I><, leConvoyeurSpec_2>;
;

+ I remplissagePack unRemplissagePack_2 
	operatedObjectSpecAttribute = 
		+ I operatedObjectSpecification,
			preExpandedList << <I><, laCuve_2>;
		; 
	;
	destinationSpecAttribute = 
		<I><, lePackSpec_2>;
	transferInformationAttribute = 
		+ I infoTransfertCuvePack info1;
	;
;

+ I fermetureBriquesPack desFermeturesBriques_2
	operatedObjectSpecAttribute = <I><, lePackSpec_2>;
;

+ I conditionnementPack unConditionnementPack_2
	operatedObjectSpecAttribute = <I><, lePackSpec_2>;
        performerSpecAttribute = <I><, lOuvrierSpec_2>; // modif JPR 090130
;

+ I stockagePack unStockagePack_2
	operatedObjectSpecAttribute = <I><, leConvoyeurSpec_2>;
;

+ I miseAuRebut uneMiseAuRebut_2
	operatedObjectSpecAttribute = <I><, leRebutSpec_2>;
;

+ I arretProduction lArretProduction_2
	operatedObjectSpecAttribute = <I><, lAtelierSpec_2>;
;

+ I alimentationManuelle uneAlimManuelle_2
	operatedObjectSpecAttribute = 
		+ I operatedObjectSpecification,
			preExpandedList << <I><, laReserveCubis_2>;
		; 
	;
;

//---------------------
// activits agrges
//---------------------

+ I activityOptional alimManuelleIfNeeded_2
	<- E <I><, uneAlimManuelle_2>;
	isOneShot = 1; 
;

+ I sequenceMiseEnMagasin uneMiseEnMagasin_2
	<- E <I><, uneCreationPack_2>;
	<- E <I><, unRemplissagePack_2>;
	<- E <I><, desFermeturesBriques_2>;
	<- E <I><, unConditionnementPack_2>;
	<- E <I><, unStockagePack_2>;
; 

+ I iterationMagasinOuRebut laProduction_2
	+ E activityConjunction unCycleDeProduction_2,
		+ E activityDisjunction magasinOuRebut_2,
				<- E <I><, uneMiseEnMagasin_2>;
				//
				<- E <I><, uneMiseAuRebut_2>;
		;
		<- E <I><,alimManuelleIfNeeded_2>;
	;
;

//---------------------
// finalement, le plan
//---------------------
<I> <,iterationPlagesTravail_2>
	+ E activityBefore sequencePlageTravail_2,
		<- E <I><, laMiseEnRoute_2>;
		//
		<- E <I><, laProduction_2>;
		//
		<- E <I><, lArretProduction_2>;
	;

      	readyToRun = 1; 
;

// *****************************************************************
// la strategie du manager
// *****************************************************************

+ I activitiesResourcesBlock arb1_2
	<- C <I><, iterationPlagesTravail_2>;
	<- C <I><, lePoolOuvrier_2>;
	attachedEntity = <I><, latelier_2>;  // + JPR 090130
;  


// ************************************************************************
// la dynamique du systme
// ************************************************************************

+ P fluxEntreeCuveLectureProcess lectureFluxEntree_2
	PAS = 5;  // 5 minutes
	NOM_SIMPLE_FICHIER "flux_2.txt";
        ENTITE_CIBLE = <I><, laCuve_2>;
	INIT_PRCD_EVT	DATE_OCCUR = 0;
			PRIORITE = 0;
	;
;

// -------------------------------------
// on programme la premire arrive de l'ouvrier
// -------------------------------------
{i2} = <pi><"POSTE" "heureDebutAM"> - <pi><"SIMULATION" "heureDebut">;
+ V arriveeOuvrier debutPoste_2  // on veut que ce soit  'heureDebutAM', donc ...
	DATE_OCCUR = {i2}*60;  // UT = 1 minute
	I resourceMobilizationProcess = <I><ouvrier lOperateurConvoyeur_2>;
// Prcision ci-dessus : explicite mais non ncessaire parce que, par dfaut,
// il y a un ProcessedEntityClassId(RESOURCE) dans le constructeur de 
// ResourceMobilizationProcess. L'entit opre est donc, par dfaut, 
// la premire instance de RESOURCE. Ici, c'est aussi la seule : l'ouvrier.
;

END INCLUDE;
